{ Composant TSystemMenu version 1.0 (30/11/97)
  Par CRESTO Sylvain
  Copyright  1997 CRESTO Sylvain (portions par Jean-Luc Mattei)
  cresto@mygale.org
  http://www.mygale.org/~cresto
  La Borde / 09230 / Contrazy / France
    ----

  Composant pour Delphi 2.0, 3.0 et C++ Builder 1.0.

  Ce composant vous permet de modifier le menu systme de votre application.
    ----

  Ce composant est un FREEWARE, vous pouvez l'utiliser dans tous vos
  programmes (commerciaux ou pas !) et les distribuer sans rien me devoir.
  Vous utilisez ce composant  vos risques et prils.
  Par contre vous * NE DEVEZ PAS * distribuer le code source * MODIFI *
  de ce composant sans avoir eu au pralable mon accord.
                                                       Merci.

  Des portions de ce code proviennent du composant ExtMenus de Jean-Luc Mattei.


  -------------

  TSystemMenu component version 1.0 (30/11/97)
  Par CRESTO Sylvain
  Copyright  1997 CRESTO Sylvain (portions by Jean-Luc Mattei)
  cresto@mygale.org
  http://www.mygale.org/~cresto
  La Borde / 09230 / Contrazy / France
    ----

  For Delphi 2.0, 3.0 and C++ Builder 1.0

  This component allows you to change the system menu (also known as control menu) of
  your application.
    ----

  This component is FREEWARE!
  No warranty is given by the author, expressed or implied.
  Do not distribute modified version without my agreement.
                                                       thanks.

  Portions of code were taken from the ExtMenus component from Jean-Luc Mattei.



}


unit SysMenu;

interface

uses

  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Menus, DsgnIntf;

type
  TAboutProperty = class(TPropertyEditor)
  private
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
    function GetValue: string; override;
  end;
  TSystemMenu = class(TComponent)
  private
    FAbout:TAboutProperty;
    FSystemMenu:TPopupMenu;
    SubCommand:array[1..20] of Integer;
    CountSub:Byte;
    aOwnerHandle:Integer;
    FTPUHandle: THandle;
    FNewTPUtilWndProcInstance:Pointer;
    FOldTPUtilWndProc:Pointer;
    FNewTFormWndProcInstance:Pointer;
    FOldTFormWndProc:Pointer;
    procedure SetSystemMenu(value:TPopupMenu);
    procedure AddMenu(menu:TMenuitem;handle:Integer);
  public
    constructor Create(aOwner : TComponent); override;
    destructor Destroy; override;
    procedure  NewTPUtilWndProc(Var Message: TMessage);
    procedure  NewTFormWndProc(Var Message: TMessage);
  published
    property About : TAboutProperty read FAbout write FAbout;
    property SystemMenu : TPopupMenu read FSystemMenu write SetSystemMenu;
  end;

procedure Register;

implementation

const FTPUCount:Integer=0;

{$R SYSMENU.RES}

procedure Register;
begin
  RegisterComponents('Standard', [TSystemMenu]);
  RegisterPropertyEditor(TypeInfo(TAboutProperty), TSystemMenu, 'ABOUT', TAboutProperty);
end;

{ TSystemMenu }

constructor TSystemMenu.Create(aOwner : Tcomponent);
  var TmpHandle:THandle;
      ProcessId:Pointer;
      TmpProcessId:Pointer;
      CName:array [0..50] of Char;
begin
  inherited create(aOwner);
  aOwnerHandle:=tform(aOwner).handle;
  CountSub:=0;
  FSystemMenu:=nil;
  if not (csDesigning in ComponentState) then
  begin
    Inc(FTPUCount);
    if (FTPUCount=1) then
    begin
      FTPUHandle:=GetNextWindow(FindWindow('TPUtilWindow',''),GW_HWNDPREV);
      GetWindowThreadProcessId(Application.Handle,@ProcessId);
      TmpHandle:=FTPUHandle;
      repeat
        FTPUHandle:=GetNextWindow(FTPUHandle,GW_HWNDNEXT);
        Windows.GetClassName(FTPUHandle,CName,50);
        if strcomp(CName,'TPUtilWindow')=0 then GetWindowThreadProcessId(FTPUHandle, @TmpProcessId)
                                           else TmpProcessId:=nil;
      until (FTPUHandle=0) or (TmpHandle=FTPUHandle) or (ProcessId=TmpProcessId);
      if (FTPUHandle<>0) and (ProcessId=TmpProcessId) then
      begin
        FNewTPUtilWndProcInstance:=MakeObjectInstance(NewTPUtilWndProc);
        FOldTPUtilWndProc:=Pointer(GetWindowLong(FTPUHandle,GWL_WNDPROC));
        SetWindowLong(FTPUHandle,GWL_WNDPROC,Longint(FNewTPUtilWndProcInstance));
      end else Dec(FTPUCount);
    end;
    FNewTFormWndProcInstance := MakeObjectInstance(NewTFormWndProc);
    FOldTFormWndProc := Pointer(GetWindowLong((Owner as TForm).Handle, GWL_WNDPROC));
    SetWindowLong((Owner as TForm).Handle, GWL_WNDPROC, Longint(FNewTFormWndProcInstance));
  end;
end;

destructor TSystemMenu.Destroy;
begin
  if not (csDesigning in ComponentState) then
  begin
    dec(FTPUCount);
    if FTPUCount=0 then
    begin
      SetWindowLong(FTPUHandle, GWL_WNDPROC, Longint(FOldTPUtilWndProc));
      FreeObjectInstance(FNewTPUtilWndProcInstance);
    end;
    if Owner is TForm then
    begin
      SetWindowLong(FTPUHandle,GWL_WNDPROC,Longint(FOldTFormWndProc));
      FreeObjectInstance(FNewTFormWndProcInstance);
    end;
  end;
  inherited Destroy;
end;

procedure TSystemMenu.NewTPUtilWndProc(Var Message: TMessage);
  var menu:tmenuitem;
      c,handle:integer;
begin
  if FSystemMenu<>nil then
  case Message.Msg of
    wm_syscommand: begin
                     menu:=FSystemMenu.finditem(Message.wparam,fkcommand);
                     if menu<>nil then menu.click;
                   end;
    wm_initmenu:   begin
                     handle:=getsystemmenu(aOwnerHandle,false);
                     if FSystemMenu.items.count>0 then
                     begin
                       for c:=0 to FSystemMenu.items.count-1 do deletemenu(handle,FSystemMenu.items[c].command,mf_bycommand);
                       if countsub>0 then for c:=1 to countsub do deletemenu(handle,subcommand[c],mf_bycommand);
                     end;
                     countsub:=0;
                     addmenu(FSystemMenu.items,handle);
                   end;
  end;
  Message.Result:= CallWindowProc(FOldTPUtilWndProc, FTPUHandle, Message.Msg, Message.WParam, Message.LParam);
end;

procedure TSystemMenu.NewTFormWndProc(Var Message: TMessage);
  var menu:tmenuitem;
      c,handle:integer;
begin
  if FSystemMenu<>nil then
    case Message.Msg of
      wm_syscommand: begin
                     menu:=FSystemMenu.finditem(Message.wparam,fkcommand);
                     if menu<>nil then menu.click;
                   end;
      wm_initmenu: begin
                     handle:=getsystemmenu(aOwnerHandle,false);
                     if FSystemMenu.items.count>0 then
                     begin
                       for c:=0 to FSystemMenu.items.count-1 do deletemenu(handle,FSystemMenu.items[c].command,mf_bycommand);
                       if countsub>0 then for c:=1 to countsub do deletemenu(handle,subcommand[c],mf_bycommand);
                     end;
                     countsub:=0;
                     addmenu(FSystemMenu.items,handle);
                   end;
    end;
  Message.Result:= CallWindowProc(FOldTFormWndProc, (Owner as TForm).Handle, Message.Msg, Message.WParam, Message.LParam);
end;

procedure TSystemMenu.SetSystemMenu(value:TPopupMenu);
begin
  FSystemMenu:=value;
end;

procedure TSystemMenu.AddMenu(menu:TMenuItem;handle:Integer);
 var h,c:integer; flags:integer;
begin
  if menu.count>0 then
  for c:=0 to menu.count-1 do
  begin
    if menu.items[c].caption<>'-' then
    begin
      if menu.items[c].count=0 then
      begin
        if menu.items[c].visible then
        begin
          flags:=mf_string;
          if menu.items[c].checked then flags:=flags+mf_checked;
          if menu.items[c].enabled=false then flags:=flags+mf_grayed;
          if menu.items[c].break=mbbreak then flags:=flags+mf_menubreak;
          if menu.items[c].break=mbbarbreak then flags:=flags+mf_menubarbreak;
          appendmenu(handle,flags,menu.items[c].command,pchar(menu.items[c].caption+#9+ShortCutToText(menu.items[c].shortcut)));
        end;
      end else
      begin
        h:=createpopupmenu;
        addmenu(menu.items[c],h);
        appendmenu(handle,mf_popup,h,pchar(menu.items[c].caption+#9+ShortCutToText(menu.items[c].shortcut)));
        if handle=getsystemmenu(aownerhandle,false) then
        begin
          countsub:=countsub+1;
          subcommand[countsub]:=h;
        end;
      end;
    end
    else appendmenu(handle,mf_separator,menu.items[c].command,nil);
  end;
end;

{ TAboutProperty }

procedure TAboutProperty.Edit;
begin
  Application.MessageBox('By CRESTO Sylvain - 1997'#13'This component (for Delphi 2.0, 3.0 and C++ Builder 1.0) is FREEWARE.'#13#13'E-Mail : cresto@mygale.org'#13'WEB : http://www.mygale.org/~cresto','SystemMenu component version 1.0', MB_OK+ MB_ICONINFORMATION);
end;

function TAboutProperty.GetAttributes: TPropertyAttributes;
begin
  GetAttributes:=[paDialog, paReadOnly];
end;

function TAboutProperty.GetValue: string;
begin
  GetValue:='(About)';
end;


end.
